package 
{
	import adobe.utils.CustomActions;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.MouseEvent;
	
	
	public class TheWorld extends Sprite
	{
		//physics
		private const amplitude:Number = 100;
		private const period:Number = 90;
		private const lambda:Number = 600;
		private var tt:Number = 0;
		
		//arrays
		private var yArray1:Array;//->
		private var yArray2:Array;//<-
		private var yArray3:Array;//sum
		private var ballArray1:Array;
		private var ballArray2:Array;
		private var ballArray3:Array;
		
		//ball
		private const nBall:int = 60;
		private var deltaX:Number = 950 / nBall;
		
		private var oneWave1:OneWave;
		private var oneWave2:OneWave;
		private var oneWave3:OneWave;
		
		//control
		private var myControl:MyControls;
		private var isPlay:Boolean = true;
		private var isStep:Boolean = false;
		
		
		public function TheWorld():void
		{
			//wave
			oneWave1 = new OneWave();
			oneWave2 = new OneWave();
			oneWave3 = new OneWave();
			oneWave1.x = oneWave2.x = oneWave3.x = 50;
			oneWave1.y = 350;
			oneWave2.y = 350;
			oneWave3.y = 350;
			this.addChild(oneWave1);
			this.addChild(oneWave2);
			this.addChild(oneWave3);
			
			//ball
			yArray1 = new Array();
			yArray2 = new Array();
			yArray3 = new Array();
			ballArray1 = new Array();
			ballArray2 = new Array();
			ballArray3 = new Array();
			for (var i:int = 0; i < nBall; i++) {
				//1
				var ball:BallMC = new BallMC();
				ball.x = i * deltaX;
				oneWave1.addChild(ball);//顯示
				ballArray1.push(ball);//呼叫ball
				yArray1.push(0);//存 y
				
				//2
				ball = new BallMC();
				ball.gotoAndStop(2);
				ball.x = i * deltaX;
				oneWave2.addChild(ball);//顯示
				ballArray2.push(ball);//呼叫ball
				yArray2.push(0);//存 y
				
				//3
				ball = new BallMC();
				ball.gotoAndStop(3);
				ball.x = i * deltaX;
				oneWave3.addChild(ball);//顯示
				ballArray3.push(ball);//呼叫ball
				yArray3.push(0);//存 y
				
			}
			
			
			
			//control
			myControl = new MyControls();
			myControl.x = 0;
			myControl.y = 600;
			this.addChild(myControl);
			
			
			myControl.btnPlay.addEventListener(MouseEvent.CLICK, clickPlay);
			myControl.btnStep.addEventListener(MouseEvent.CLICK, clickStep);
			
			
			this.addEventListener(Event.ENTER_FRAME, myshow);
		}
		
		
		private function myshow(e:Event):void {
			//tt
			if(isPlay){
				tt++;
			}
			if (isStep) {
				isPlay = false;
			}
			
			//y
			for (var i:int = 0; i < nBall; i++) {
				//1
				yArray1[i] = amplitude * Math.sin(2 * Math.PI * (i * deltaX) / lambda - 2 * Math.PI * tt / period);
				ballArray1[i].y = yArray1[i];
				
				//2
				yArray2[i] = amplitude * Math.sin( -2 * Math.PI * (i * deltaX) / lambda - 2 * Math.PI * tt / period);
				ballArray2[i].y = yArray2[i];
				
				//3
				yArray3[i] = yArray1[i] + yArray2[i];
				ballArray3[i].y = yArray3[i];
				
			}
			
			//visible
			oneWave1.visible = myControl.ch01.selected;
			oneWave2.visible = myControl.ch02.selected;
			oneWave3.visible = myControl.ch03.selected;
			
		}
		
		
		private function clickPlay(e:MouseEvent):void {
			if (isStep) {
				isStep = false;
				isPlay = true;
			}else {
				isPlay = !isPlay;
			}
		}
		private function clickStep(e:MouseEvent):void {
			isStep = true;
			isPlay = true;
		}
		
	}

}